
/*

  cps1 rom reading routines

*/


#ifndef CPS1ROMSPACE_H
#define CPS1ROMSPACE_H

#include "romspace.h"

class cps1romspace:public tRomSpace
{
private:

	void decodesprites(int num,unsigned char *src,unsigned char** dest);
	void decodechars(int num,unsigned char *src,unsigned char** dest);
	void decodetiles16(int num,unsigned char *src,unsigned char** dest);
	void decodetiles32(int num,unsigned char *src,unsigned char** dest);

public:

	cps1romspace();
	~cps1romspace();
	int readRoms(char* path,char* romsetname,tCharset**);
	void decodeCharset(tCharset*);
} ;


#endif