
/*

	video render
	many effectz

*/

#include "render.h"

//

int render::vbufx;
int render::vbufy;
unsigned long int* render::oldframe;

//

render::render(int vbx,int vby)
{
	vbufx=vbx;
	vbufy=vby;

	oldframe=new unsigned long int [vbufx*vbufy];
	memset(oldframe,0,vbufx*vbufy*4);

	blitter=stdblitter;
}

render::~render()
{
	delete [] oldframe;
}

void render::setRenderer(int m)
{
	if (m==0)
	{
		blitter=stdblitter;
	}
	else if (m==1)
	{
		blitter=scanlines50;
	}
	else if (m==2)
	{
		blitter=scanlines75;
	}
}

void render::apply(unsigned long int* buf)
{
	blitter(buf);
}

// renderers

void render::stdblitter(unsigned long int* buf)
{

}

void render::scanlines50(unsigned long int* buf)
{
	// scanlines

	int ar,ag,ab;
	int r,c;
	unsigned long int* pbuf=buf;
	unsigned char* cpbuf=(unsigned char*)buf;

	for (r=0;r<vbufy;r+=2)
	{
		for (c=0;c<vbufx;c++)
		{
			ar=(*cpbuf)>>1;
			cpbuf++;
			ag=(*cpbuf)>>1;
			cpbuf++;
			ab=(*cpbuf)>>1; 
			cpbuf+=2;

			*pbuf=((ar)|(ag<<8)|(ab<<16));
			pbuf++;
		}
		pbuf+=vbufx;
		cpbuf+=vbufx*4;
	}
}

void render::scanlines75(unsigned long int* buf)
{
	// more scanlines

	int ar,ag,ab;
	int r,c;
	unsigned long int* pbuf=buf;
	unsigned char* cpbuf=(unsigned char*)buf;

	for (r=0;r<vbufy;r+=2)
	{
		for (c=0;c<vbufx;c++)
		{
			ar=((*cpbuf)*768)>>10;
			cpbuf++;
			ag=((*cpbuf)*768)>>10;
			cpbuf++;
			ab=((*cpbuf)*768)>>10; 
			cpbuf+=2;

			*pbuf=((ar)|(ag<<8)|(ab<<16));
			pbuf++;
		}
		pbuf+=vbufx;
		cpbuf+=vbufx*4;
	}
}

