
/*

	video renderer
	19/01/02

*/


#ifndef RENDER_H
#define RENDER_H

#include <string.h>


class render
{
private:

	static int vbufx,vbufy;
	static unsigned long int* oldframe;
	void (*blitter)(unsigned long int*);

	// renderers

	static void stdblitter(unsigned long int*);
	static void scanlines50(unsigned long int*);
	static void scanlines75(unsigned long int*);
	static void twoframe(unsigned long int*);

public:

	render(int,int);
	~render();
	void setRenderer(int m);
	void apply(unsigned long int* buf);
};

#endif